#!/usr/bin/ruby
# 
# 2010      Nico Schottelius (nico-fui at schottelius.org)
# 
# This file is part of fui.
#
# fui is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# fui is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with fui. If not, see <http://www.gnu.org/licenses/>.
#
# Connect to the ceof-socket
#

require 'socket.so'
include Socket::Constants

class FuiSocket
   attr_reader :socketpath

   def initialize(socketpath)
      @socketpath = socketpath
      @socket = Socket.new(AF_UNIX, SOCK_STREAM, 0)
      @sockaddr = Socket::sockaddr_un(@socketpath)
      @socket.connect @sockaddr
   end

   def send(msg)
      @socket.send(msg, msg.length)
   end

   def recv(length)
      @socket.recv length
   end

   def close
      @socket.close
   end

end

